package ass.sivakfil.hw8.server.impl;

import io.reactivex.Observable;

import java.io.IOException;
import java.net.SocketAddress;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.util.Iterator;

import ass.sivakfil.hw8.server.IRequest;
import ass.sivakfil.hw8.server.IRequestHandler;
import ass.sivakfil.hw8.server.IResponseWriter;
import ass.sivakfil.hw8.server.IServer;

public class Server implements IServer {
	
	/**
	 * Address that server will bind to
	 */
	protected SocketAddress address;
	protected boolean exit = false;
	
	/* 
	 * TODO
	 * Use RxJava Subject
	 * You can use PublishSubject, which is instantiated by PublishSubject.create()
	 */
	protected Observable<IRequest> requests = null /* TODO: change this */;
	
	public Server(SocketAddress address) {
		this.address = address;
	}
	
	public void run(IRequestHandler handler, IResponseWriter writer, String delimiter) throws IOException {
		// open, bind and configure ServerSocketChannel
		ServerSocketChannel serverChannel = ServerSocketChannel.open();
		serverChannel.bind(address);
		serverChannel.configureBlocking(false);

		System.out.println("Server started on address:" + address);
		
		// open selector and register serverSocketChannel to it
		Selector sel = Selector.open();
		serverChannel.register(sel, serverChannel.validOps());
		
		// use compose operator on RxJava Observable requests to handle requests using provided handler
		// use response writer to write response to client
		// TODO
		
		// start non-blocking loop
		while(!exit) {
			sel.select();
			Iterator<SelectionKey> iterator = sel.selectedKeys().iterator();
			Observable<SelectionKey> validKeys = Observable.<SelectionKey>create((emittor) -> {
				while(iterator.hasNext()) {
					SelectionKey next = iterator.next();
					emittor.onNext(next);
					iterator.remove();	// this is important, as selector only adds but does not remove
				}
				emittor.onComplete();
			})
			.filter(key -> key.isValid())
			.cache();
			
			// using valid keys observable:
				// 1) clientChannel <- accept on acceptable key
				// 2) clientChannel.configureBlocking(false);
				// 3) clientChannel.register(selector, SelectionKey.OP_READ);
				// TODO
				
				// 1) (SocketChannel)key.channel() on readable key
				// 2) read from channel (you can use ByteBufferUtil)
				// 3) append data to some kind of buffer (ByteBuffer, ByteArrayOutputStream, StringBuilder, ...)
				//		this might have tremendous impact on performance, but beware of premature optimization
				//		note that speed is not primary objective of this homework
				// 4) construct request object when whole message is stored in buffer (message is terminated by terminator string)
				// 5) emit request object into observable 
				//	(hint: using PublishSubject is convenient)
				// TODO
		}
	}

}
